; *****************************************************************************
; *          HOL-OCL - a shallow embedding of OCL in Isabelle/HOL
; *
; * x-symbol-holocl-startup.el  - HOL-OCL x-symbol minor mode
; * Copyright (C) 2005 Achim D. Brucker <brucker@inf.ethz.ch>
; *
; * This file is part of HOL-OCL.
; *
; * HOL-OCL is free software; you can redistribute it and/or modify it under
; * the terms of the GNU General Public License as published by the Free
; * Software Foundation; either version 2 of the License, or (at your option)
; * any later version.
; *
; * HOL-OCL is distributed in the hope that it will be useful, but WITHOUT ANY
; * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
; * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
; * details.
; *
; * You should have received a copy of the GNU General Public License along
; * with this program; if not, write to the Free Software Foundation, Inc.,
; * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
; ******************************************************************************

; please add the following two lines to .emacs file:
; (add-to-list 'load-path (concat (getenv "HOLOCL_HOME") "/etc/"))
; (require 'x-symbol-holocl-startup)

(setq x-symbol-font-directory (concat (getenv "HOLOCL_HOME") "/etc/fonts/"))


(defvar x-symbol-holocl-name "HOL-OCL")
(defvar x-symbol-holocl-modes nil)

;; loading isasym x-symbol mode (replaces \isasymX by its representation)
(defvar x-symbol-isasymtex-name "IsaSym TeX")
(defvar x-symbol-isasymtex-modes nil)



(eval-after-load "isabelle-system"
  '(progn
      (defpgdefault x-symbol-language 'holocl)
     ))

(eval-after-load "x-symbol"
  '(progn
      (x-symbol-initialize '(font-path))
      (x-symbol-register-language 'holocl 'x-symbol-holocl x-symbol-holocl-modes)
      (x-symbol-register-language 'isasymtex 'x-symbol-isasymtex x-symbol-isasymtex-modes)
      (setq x-symbol-token-language 'holocl)
     ))

(provide 'x-symbol-holocl-startup)
