(*****************************************************************************
 *          HOL-OCL - a shallow embedding of OCL in Isabelle/HOL              
 *                                                                            
 * company.thy - 
 * Copyright (C) 2006 Achim D. Brucker <brucker@inf.ethz.ch>   
 *                                                                            
 * This File is part of HOL-OCL.                                              
 *                                                                            
 * HOL-OCL is free software; you can redistribute it and/or modify it under   
 * the terms of the GNU General Public License as published by the Free       
 * Software Foundation; either version 2 of the License, or (at your option)  
 * any later version.                                                         
 *                                                                            
 * HOL-OCL is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.                                                              
 *                                                                            
 * You should have received a copy of the GNU General Public License along    
 * with this program; if not, write to the Free Software Foundation, Inc.,    
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                  
 ******************************************************************************)


header {* Company *}


theory company 
imports
OCL
begin

text {*
We use the class diagram presented in Fig.~\ref{fig:company_classdiag} together with the 
following \OCL formulae: 
%shown in Tab.~\ref{tab:company_ocl}

%\begin{table}
\begin{small}
\lstinputlisting[style=ocl]{company.ocl}
\end{small}
%\caption{OCL specification\label{tab:company_ocl}} 
%\end{table}

\begin{figure}
\begin{center}
\includegraphics[scale=.6]{company}
\end{center}
\caption{A company Class Diagramm\label{fig:company_classdiag}}
\end{figure}

*}

ML {* invariant_encoder.transformations :=  ([]: (string * (Rep_Core.Classifier list 
                                                    -> Rep_Core.Classifier 
                                                    -> Rep_HolOclTerm.HolOclTerm 
                                                    -> Rep_HolOclTerm.HolOclTerm)) list)
    *}
load_xmi "company_ocl.xmi"

end
