// $Id: TransactionTest.java,v 1.1 2000/09/21 13:28:58 brucker Exp $
package unifreiburg.informatik.softech.ebank.test;
import unifreiburg.informatik.softech.ebank.*;
import java.util.*;

public class TransactionTest extends TestSuite {
    public String getTestSuiteName() {
        return "Test of Transaction object";
    }
    public boolean testSimpleTransaction() {
        boolean retval=false;
	super.printTestCaseName("Testing simple Transaction");
	BankAccount source      = new BankAccount(3);
        BankAccount destination = new BankAccount(4);
	Transaction transaction = new Transaction();
	
	source.makeDeposit(500.0);
	transaction.source      = source;
	transaction.destination = destination;
	transaction.setAmount(450);
	transaction.makeTransfer();
	
	if(source.getBalance()!=50.0) {
	    retval = false;
	}
	if(destination.getBalance()!=450.0) {
	    retval = false;
	}
	return true;
    }
    public boolean testAmountZero() {
        boolean retval=false;
	super.printTestCaseName("Testing amount 0.0");
	BankAccount source      = new BankAccount(3);
        BankAccount destination = new BankAccount(4);
	Transaction transaction = new Transaction();
	
	source.makeDeposit(500.0);
	transaction.source      = source;
	transaction.destination = destination;
	transaction.setAmount(0);
	transaction.makeTransfer();
	
	if(source.getBalance()!=500.0) {
	    retval = false;
	}
	if(destination.getBalance()!=0.0) {
	    retval = false;
	}
	return true;
    }
    public boolean testSourceEqualDest() {
        boolean retval=false;
	super.printTestCaseName("Testing source and destination equal");
	BankAccount account      = new BankAccount(3);
	Transaction transaction = new Transaction();
	
	account.makeDeposit(500.0);
	transaction.source      = account;
	transaction.destination = account;
	transaction.setAmount(450);
	transaction.makeTransfer();
	
	if(account.getBalance()!=500.0) {
	    retval = false;
	}
	return true;
    }
}
