(*****************************************************************************
 *          HOL-OCL - a shallow embedding of OCL in Isabelle/HOL              
 *                                                                            
 * test.thy - 
 * Copyright (C) 2004,2005 Achim D. Brucker <brucker@inf.ethz.ch>   
 *                                                                            
 * This File is part of HOL-OCL.                                              
 *                                                                            
 * HOL-OCL is free software; you can redistribute it and/or modify it under   
 * the terms of the GNU General Public License as published by the Free       
 * Software Foundation; either version 2 of the License, or (at your option)  
 * any later version.                                                         
 *                                                                            
 * HOL-OCL is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.                                                              
 *                                                                            
 * You should have received a copy of the GNU General Public License along    
 * with this program; if not, write to the Free Software Foundation, Inc.,    
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                  
 ******************************************************************************)


header {* Encoding \UML/\OCL into \HOL by Example *}


theory simple  = OCL:

ML {* val _ = writeInfoFile "/tmp/holoclinfo.txt" *}
text  {* \verbatiminput {/tmp/holoclinfo.txt} *}


text {*
In this section we present the details of our encoding by an example. We 
use the class diagram presented in Fig.~\ref{fig:simple_classdiag} together with the 
following \OCL formulae: 
%shown in Tab.~\ref{tab:simple_ocl}

%\begin{table}
\begin{small}
\lstinputlisting[style=ocl]{simple.ocl}
\end{small}
%\caption{OCL specification\label{tab:simple_ocl}} 
%\end{table}

\begin{figure}
\begin{center}
\includegraphics[scale=.6]{simple}
\end{center}
\caption{A simple Class Diagramm\label{fig:simple_classdiag}}
\end{figure}

*}


load_xmi "simple_ocl.xmi"



lemma level1_is_A_cp: "cp (level1.simple.is_A)"
  apply(unfold level1.simple.is_A_def)
  apply(simp add: cp_lift1)
  done
lemmas level1_is_A_cp' = level1.simple.is_A_def [THEN cp_lift1_fw, standard] 


lemma is_A_cp: "cp (simple.is_A)"
apply(simp)
done

lemma repabs: "Rep_Set_0 (Abs_Set_0 \<HolOclLiftLeft>(\<lambda>x. x St) ` range simple.get_A - {down}\<HolOclLiftRight>)=\<HolOclLiftLeft>(\<lambda>x. x St) ` range simple.get_A - {down}\<HolOclLiftRight>"
apply (rule Abs_Set_0_inverse)
apply (simp add: OCL_Set_type.Set_0_def smash_def)
done

axioms  foot: "St \<MathOclValid> \<MathOclIsDefined> (simple.get_A obj) \<Longrightarrow> St \<MathOclValid>  simple.is_A(simple.get_A obj)"


(* add cp proofs for all generated definitions on level 1 and 2 *)


(*
defs         
oclAsType_A: "oclAsType self X == (A_2_OclAny self)"

defs 
 foo_def:  "oclIsKindOf obj (X) ==  (obj \<MathOclIncludes> simple.A)"


lemma   in_IntegerR[simp]: 
lemma   in_IntegerR[simp]: 

"(\<tau> \<MathOclValid>  (x::'a INTEGER) \<MathOclIncludes>  (Integer::('a,Integer)SET)) = 
 (\<tau> \<MathOclValid> \<MathOclIsDefined>  x)"
lemma   in_Integer: 
"\<tau> \<MathOclValid> \<MathOclIsDefined>  x \<Longrightarrow>
 \<tau> \<MathOclValid> (x::'a INTEGER) \<MathOclIncludes> (Integer::('a,Integer)SET)"

apply


Exhausten und Distincness:

C \<union> D  \<subseteq>  A

C \<inter> D = \<emptyset> 
*)

(*
lemma mk_get_A_id :
  "St \<MathOclValid> simple.is_A_univ univ  \<Longrightarrow> simple.mk_A (simple.get_A univ) St = univ St" 
  apply (frule isDefined_if_valid)
  apply (frule  localValidDefined2sem [THEN iffD1])
  apply (unfold simple.is_A_univ_def simple.is_A_def simple.get_A_def 
    simple.mk_A_def OclLocalValid_def)
  apply(simp add:  OclLocalValid_def   lift1_def lift0_def OclTrue_def strictify_def DEF_def  )
  apply(case_tac "obj St = down")
  apply(auto simp: level1.simple.mk_get_A_id)
done

lemma  is_A_univ_implies_is_get: 
  "\<lbrakk>  DEF(simple.simple.get_A univ St); (St \<MathOclValid>  simple.simple.is_A_univ univ) \<rbrakk>  \<Longrightarrow>  (St \<MathOclValid>     simple.simple.is_A (simple.simple.get_A univ))"
  apply (frule isDefined_if_valid)
  apply (frule  localValidDefined2sem [THEN iffD1])
  apply (unfold simple.simple.is_A_univ_def simple.simple.is_A_def simple.simple.get_A_def 
    simple.simple.mk_A_def OclLocalValid_def)
  apply(simp add:  OclLocalValid_def   lift1_def lift0_def OclTrue_def strictify_def DEF_def  )
thm is_A_univ_implies_is_get
 apply(case_tac "obj St = down")
  apply(auto simp: level1.is_A_univ_implies_is_get)
done

lemma is_mk_A:
  "St \<MathOclValid>  simple.simple.is_A obj \<Longrightarrow>   (St \<MathOclValid>   simple.simple.is_A_univ (simple.simple.mk_A obj))"
  apply (frule isDefined_if_valid)
  apply (frule  localValidDefined2sem [THEN iffD1])
  apply (unfold simple.simple.is_A_univ_def simple.simple.is_A_def simple.simple.get_A_def 
    simple.simple.mk_A_def OclLocalValid_def)
  apply(simp add:  OclLocalValid_def   lift1_def lift0_def OclTrue_def strictify_def DEF_def  )
  apply(case_tac "obj St = down")
  apply(auto simp: level1.simple.is_mk_A)
done

*)


chapter {* Encoding a Simple \UML/\OCL Model *}
section {* Level 0: The Raw Data Modell *}
subsection {* Class A *}
subsubsection {* Trunk: *} 
(*<*) thm "UML_OCL.level0.simple.mk_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.mk_A_def } *} 
(*<*) thm "UML_OCL.level0.simple.get_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.get_A_def } *} 
(*<*) thm "UML_OCL.level0.simple.is_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_A_def } *} 
(*<*) thm "UML_OCL.level0.simple.is_A_univ_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_A_univ_def } *} 
(*<*) thm "UML_OCL.level0.simple.A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.A_def } *} 
(*<*) thm "UML_OCL.level0.simple.A_2_OclAny_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.A_2_OclAny_def } *} 
(*<*) thm "UML_OCL.level0.simple.OclAny_2_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.OclAny_2_A_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "UML_OCL.level0.simple.A.i_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.A.i_def } *} 
(*<*) thm "UML_OCL.level0.simple.A.b_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.A.b_def } *} 
(*<*) thm "UML_OCL.level0.simple.A.r_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.A.r_def } *} 

subsubsection {* Proofs: *} 
(*<*) thm "UML_OCL.level0.simple.is_A_univ_implies_OclAny_univ" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_A_univ_implies_OclAny_univ } *}
(*<*) thm "UML_OCL.level0.simple.is_A_univ_implies_is_get" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_A_univ_implies_is_get } *}
(*<*) thm "get_mk_A_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.get_mk_A_id } *}
(*<*) thm "UML_OCL.level0.simple.is_mk_A" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_mk_A } *}
(*<*) thm "UML_OCL.level0.simple.is_OclAny_mk_A" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_OclAny_mk_A} *}
(*<*) thm "UML_OCL.level0.simple.mk_get_A_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.mk_get_A_id } *}
(*<*) thm "UML_OCL.level0.simple.cast_A_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.cast_A_id } *}

subsection {* Class C *}
subsubsection {* Trunk: *} 
(*<*) thm "UML_OCL.level0.simple.mk_C_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.mk_C_def } *} 
(*<*) thm "UML_OCL.level0.simple.get_C_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.get_C_def } *} 
(*<*) thm "UML_OCL.level0.simple.is_C_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_C_def } *} 
(*<*) thm "UML_OCL.level0.simple.is_C_univ_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_C_univ_def } *} 
(*<*) thm "UML_OCL.level0.simple.C_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.C_def } *} 
(*<*) thm "UML_OCL.level0.simple.C_2_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.C_2_A_def } *} 
(*<*) thm "UML_OCL.level0.simple.A_2_C_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.A_2_C_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "UML_OCL.level0.simple.C.s_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.C.s_def } *} 

subsubsection {* Proofs: *} 
(*<*) thm "UML_OCL.level0.simple.is_C_univ_implies_A_univ" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_C_univ_implies_A_univ } *}
(*<*) thm "UML_OCL.level0.simple.is_C_univ_implies_is_get" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_C_univ_implies_is_get } *}
(*<*) thm "UML_OCL.level0.simple.get_mk_C_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.get_mk_C_id } *}
(*<*) thm "UML_OCL.level0.simple.is_mk_C" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_mk_C } *}
(*<*) thm "UML_OCL.level0.simple.is_A_mk_C" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_A_mk_C } *}
(*<*) thm "UML_OCL.level0.simple.mk_get_C_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.mk_get_C_id } *}
(*<*) thm "UML_OCL.level0.simple.cast_C_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.cast_C_id } *}

subsection {* Class D *}
subsubsection {* Trunk: *} 
(*<*) thm "UML_OCL.level0.simple.mk_D_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.mk_D_def } *} 
(*<*) thm "UML_OCL.level0.simple.get_D_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.get_D_def } *} 
(*<*) thm "UML_OCL.level0.simple.is_D_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_D_def } *} 
(*<*) thm "UML_OCL.level0.simple.is_D_univ_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_D_univ_def } *} 
(*<*) thm "UML_OCL.level0.simple.D_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.D_def } *} 
(*<*) thm "UML_OCL.level0.simple.D_2_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.D_2_A_def } *} 
(*<*) thm "UML_OCL.level0.simple.A_2_D_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.A_2_D_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "UML_OCL.level0.simple.D.r_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.D.r_def } *} 

subsubsection {* Proofs: *} 
(*<*) thm "UML_OCL.level0.simple.is_D_univ_implies_A_univ" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_D_univ_implies_A_univ } *}
(*<*) thm "UML_OCL.level0.simple.is_D_univ_implies_is_get" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_D_univ_implies_is_get } *}
(*<*) thm "UML_OCL.level0.simple.get_mk_D_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.get_mk_D_id } *}
(*<*) thm "UML_OCL.level0.simple.is_mk_D" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_mk_D } *}
(*<*) thm "UML_OCL.level0.simple.is_A_mk_D" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_A_mk_D } *}
(*<*) thm "UML_OCL.level0.simple.mk_get_D_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.mk_get_D_id } *}
(*<*) thm "UML_OCL.level0.simple.cast_D_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.cast_D_id } *}

subsection {* Class B *}
subsubsection {* Trunk: *} 
(*<*) thm "UML_OCL.level0.simple.mk_B_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.mk_B_def } *} 
(*<*) thm "UML_OCL.level0.simple.get_B_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.get_B_def } *} 
(*<*) thm "UML_OCL.level0.simple.is_B_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_B_def } *} 
(*<*) thm "UML_OCL.level0.simple.is_B_univ_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_B_univ_def } *} 
(*<*) thm "UML_OCL.level0.simple.B_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.B_def } *} 
(*<*) thm "UML_OCL.level0.simple.B_2_OclAny_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.B_2_OclAny_def } *} 
(*<*) thm "UML_OCL.level0.simple.OclAny_2_B_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.OclAny_2_B_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "UML_OCL.level0.simple.B.a_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.B.a_def } *} 
(*<*) thm "UML_OCL.level0.simple.B.j_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.B.j_def } *} 


subsubsection {* Proofs: *} 
(*<*) thm "UML_OCL.level0.simple.is_B_univ_implies_OclAny_univ" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_B_univ_implies_OclAny_univ } *}
(*<*) thm "UML_OCL.level0.simple.is_B_univ_implies_is_get" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_B_univ_implies_is_get } *}
(*<*) thm "UML_OCL.level0.simple.get_mk_B_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.get_mk_B_id } *}
(*<*) thm "UML_OCL.level0.simple.is_mk_B" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_mk_B } *}
(*<*) thm "UML_OCL.level0.simple.is_OclAny_mk_B" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_OclAny_mk_B } *}
(*<*) thm "UML_OCL.level0.simple.mk_get_B_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.mk_get_B_id } *}
(*<*) thm "UML_OCL.level0.simple.cast_B_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.cast_B_id } *}

subsection {* Class E *}
subsubsection {* Trunk: *} 
(*<*) thm "UML_OCL.level0.simple.mk_E_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.mk_E_def } *} 
(*<*) thm "UML_OCL.level0.simple.get_E_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.get_E_def } *} 
(*<*) thm "UML_OCL.level0.simple.is_E_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_E_def } *} 
(*<*) thm "UML_OCL.level0.simple.is_E_univ_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_E_univ_def } *} 
(*<*) thm "UML_OCL.level0.simple.E_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.E_def } *} 
(*<*) thm "UML_OCL.level0.simple.E_2_B_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.E_2_B_def } *} 
(*<*) thm "UML_OCL.level0.simple.B_2_E_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.B_2_E_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "UML_OCL.level0.simple.E.r_def" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.E.r_def } *} 

subsubsection {* Proofs: *} 
(*<*) thm "UML_OCL.level0.simple.is_E_univ_implies_B_univ" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_E_univ_implies_B_univ } *}
(*<*) thm "UML_OCL.level0.simple.is_E_univ_implies_is_get" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_E_univ_implies_is_get } *}
(*<*) thm "UML_OCL.level0.simple.get_mk_E_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.get_mk_E_id } *}
(*<*) thm "UML_OCL.level0.simple.is_mk_E" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_mk_E } *}
(*<*) thm "UML_OCL.level0.simple.is_B_mk_E" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.is_B_mk_E } *}
(*<*) thm "UML_OCL.level0.simple.mk_get_E_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.mk_get_E_id } *}
(*<*) thm "UML_OCL.level0.simple.cast_E_id" (*>*) 
   text {* @{thm [display] UML_OCL.level0.simple.cast_E_id } *}


   section {* Level 1: Adding State*}
subsection {* Class A *}
subsubsection {* Trunk: *} 
(*<*) thm "UML_OCL.level1.simple.mk_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.mk_A_def } *} 
(*<*) thm "UML_OCL.level1.simple.get_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.get_A_def } *} 
(*<*) thm "UML_OCL.level1.simple.is_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_A_def } *} 
(*<*) thm "UML_OCL.level1.simple.is_A_univ_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_A_univ_def } *} 
(*<*) thm "UML_OCL.level1.simple.A_2_OclAny_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.A_2_OclAny_def } *} 
(*<*) thm "UML_OCL.level1.simple.OclAny_2_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.OclAny_2_A_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "UML_OCL.level1.simple.A.i_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.A.i_def } *} 
(*<*) thm "UML_OCL.level1.simple.A.b_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.A.b_def } *} 
(*<*) thm "UML_OCL.level1.simple.A.r_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.A.r_def } *} 

subsubsection {* Proofs: *} 
(*<*) thm "UML_OCL.level1.simple.is_A_univ_implies_OclAny_univ" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_A_univ_implies_OclAny_univ } *}
(*<*) thm "UML_OCL.level1.simple.is_A_univ_implies_is_get" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_A_univ_implies_is_get } *}
(*<*) thm "UML_OCL.level1.simple.get_mk_A_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.get_mk_A_id } *}
(*<*) thm "UML_OCL.level1.simple.is_mk_A" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_mk_A } *}
(*<*) thm "UML_OCL.level1.simple.is_OclAny_mk_A" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_OclAny_mk_A} *}
(*<*) thm "UML_OCL.level1.simple.mk_get_A_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.mk_get_A_id } *}
(*<*) thm "UML_OCL.level1.simple.cast_A_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.cast_A_id } *}


subsection {* Class C *}
subsubsection {* Trunk: *} 
(*<*) thm "UML_OCL.level1.simple.mk_C_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.mk_C_def } *} 
(*<*) thm "UML_OCL.level1.simple.get_C_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.get_C_def } *} 
(*<*) thm "UML_OCL.level1.simple.is_C_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_C_def } *} 
(*<*) thm "UML_OCL.level1.simple.is_C_univ_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_C_univ_def } *} 
(*<*) thm "UML_OCL.level1.simple.C_2_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.C_2_A_def } *} 
(*<*) thm "UML_OCL.level1.simple.A_2_C_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.A_2_C_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "UML_OCL.level1.simple.C.s_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.C.s_def } *} 

subsubsection {* Proofs: *} 
(*<*) thm "UML_OCL.level1.simple.is_C_univ_implies_A_univ" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_C_univ_implies_A_univ } *}
(*<*) thm "UML_OCL.level1.simple.is_C_univ_implies_is_get" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_C_univ_implies_is_get } *}
(*<*) thm "UML_OCL.level1.simple.get_mk_C_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.get_mk_C_id } *}
(*<*) thm "UML_OCL.level1.simple.is_mk_C" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_mk_C } *}
(*<*) thm "UML_OCL.level1.simple.is_A_mk_C" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_A_mk_C } *}
(*<*) thm "UML_OCL.level1.simple.mk_get_C_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.mk_get_C_id } *}
(*<*) thm "UML_OCL.level1.simple.cast_C_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.cast_C_id } *}


subsection {* Class D *}
subsubsection {* Trunk: *} 
(*<*) thm "UML_OCL.level1.simple.mk_D_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.mk_D_def } *} 
(*<*) thm "UML_OCL.level1.simple.get_D_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.get_D_def } *} 
(*<*) thm "UML_OCL.level1.simple.is_D_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_D_def } *} 
(*<*) thm "UML_OCL.level1.simple.is_D_univ_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_D_univ_def } *} 
(*<*) thm "UML_OCL.level1.simple.D_2_A_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.D_2_A_def } *} 
(*<*) thm "UML_OCL.level1.simple.A_2_D_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.A_2_D_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "UML_OCL.level1.simple.D.r_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.D.r_def } *} 

subsubsection {* Proofs: *} 
(*<*) thm "UML_OCL.level1.simple.is_D_univ_implies_A_univ" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_D_univ_implies_A_univ } *}
(*<*) thm "UML_OCL.level1.simple.is_D_univ_implies_is_get" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_D_univ_implies_is_get } *}
(*<*) thm "UML_OCL.level1.simple.get_mk_D_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.get_mk_D_id } *}
(*<*) thm "UML_OCL.level1.simple.is_mk_D" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_mk_D } *}
(*<*) thm "UML_OCL.level1.simple.is_A_mk_D" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_A_mk_D } *}
(*<*) thm "UML_OCL.level1.simple.mk_get_D_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.mk_get_D_id } *}
(*<*) thm "UML_OCL.level1.simple.cast_D_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.cast_D_id } *}

subsection {* Class B *}
subsubsection {* Trunk: *} 
(*<*) thm "UML_OCL.level1.simple.mk_B_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.mk_B_def } *} 
(*<*) thm "UML_OCL.level1.simple.get_B_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.get_B_def } *} 
(*<*) thm "UML_OCL.level1.simple.is_B_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_B_def } *} 
(*<*) thm "UML_OCL.level1.simple.is_B_univ_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_B_univ_def } *} 
(*<*) thm "UML_OCL.level1.simple.B_2_OclAny_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.B_2_OclAny_def } *} 
(*<*) thm "UML_OCL.level1.simple.OclAny_2_B_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.OclAny_2_B_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "UML_OCL.level1.simple.B.a_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.B.a_def } *} 
(*<*) thm "UML_OCL.level1.simple.B.j_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.B.j_def } *} 

subsubsection {* Proofs: *} 
(*<*) thm "UML_OCL.level1.simple.is_B_univ_implies_OclAny_univ" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_B_univ_implies_OclAny_univ } *}
(*<*) thm "UML_OCL.level1.simple.is_B_univ_implies_is_get" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_B_univ_implies_is_get } *}
(*<*) thm "UML_OCL.level1.simple.get_mk_B_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.get_mk_B_id } *}
(*<*) thm "UML_OCL.level1.simple.is_mk_B" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_mk_B } *}
(*<*) thm "UML_OCL.level1.simple.is_OclAny_mk_B" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_OclAny_mk_B } *}
(*<*) thm "UML_OCL.level1.simple.mk_get_B_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.mk_get_B_id } *}
(*<*) thm "UML_OCL.level1.simple.cast_B_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.cast_B_id } *}


subsection {* Class E *}
subsubsection {* Trunk: *} 
(*<*) thm "UML_OCL.level1.simple.mk_E_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.mk_E_def } *} 
(*<*) thm "UML_OCL.level1.simple.get_E_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.get_E_def } *} 
(*<*) thm "UML_OCL.level1.simple.is_E_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_E_def } *} 
(*<*) thm "UML_OCL.level1.simple.is_E_univ_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_E_univ_def } *} 
(*<*) thm "UML_OCL.level1.simple.E_2_B_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.E_2_B_def } *} 
(*<*) thm "UML_OCL.level1.simple.B_2_E_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.B_2_E_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "UML_OCL.level1.simple.E.r_def" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.E.r_def } *} 

subsubsection {* Proofs: *} 
(*<*) thm "UML_OCL.level1.simple.is_E_univ_implies_B_univ" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_E_univ_implies_B_univ } *}
(*<*) thm "UML_OCL.level1.simple.is_E_univ_implies_is_get" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_E_univ_implies_is_get } *}
(*<*) thm "UML_OCL.level1.simple.get_mk_E_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.get_mk_E_id } *}
(*<*) thm "UML_OCL.level1.simple.is_mk_E" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_mk_E } *}
(*<*) thm "UML_OCL.level1.simple.is_B_mk_E" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.is_B_mk_E } *}
(*<*) thm "UML_OCL.level1.simple.mk_get_E_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.mk_get_E_id } *}
(*<*) thm "UML_OCL.level1.simple.cast_E_id" (*>*) 
   text {* @{thm [display] UML_OCL.level1.simple.cast_E_id } *}


section {* Level 2: Adding \OCL *}
subsection {* Class A *}
subsubsection {* Basic Invariants *} 
(*
(*<*) thm "simple.A.model.hol_invariant.inv_1_def" (*>*) 
   text {* @{thm [display] simple.A.model.hol_invariant.inv_1_def } *} 
*)
(*<*) thm "simple.A.model.hol_invariant_def" (*>*) 
   text {* @{thm [display] simple.A.model.hol_invariant_def } *} 

subsubsection {* Trunk: *} 
(*<*) thm "simple.mk_A_def" (*>*) 
   text {* @{thm [display] simple.mk_A_def } *} 
(*<*) thm "simple.get_A_def" (*>*) 
   text {* @{thm [display] simple.get_A_def } *} 
(*<*) thm "simple.is_A_def" (*>*) 
   text {* @{thm [display] simple.is_A_def } *} 
(*<*) thm "simple.is_A_univ_def" (*>*) 
   text {* @{thm [display] simple.is_A_univ_def } *} 
(*<*) thm "simple.A_def" (*>*) 
   text {* @{thm [display] simple.A_def } *} 
(*<*) thm "simple.A_2_OclAny_def" (*>*) 
   text {* @{thm [display] simple.A_2_OclAny_def } *} 
(*<*) thm "simple.OclAny_2_A_def" (*>*) 
   text {* @{thm [display] simple.OclAny_2_A_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "simple.A.i_def" (*>*) 
   text {* @{thm [display] simple.A.i_def } *} 
(*<*) thm "simple.A.i_pre_def" (*>*) 
   text {* @{thm [display] simple.A.i_pre_def } *} 
(*<*) thm "simple.A.b_def" (*>*) 
   text {* @{thm [display] simple.A.b_def } *} 
(*<*) thm "simple.A.b_pre_def" (*>*) 
   text {* @{thm [display] simple.A.b_pre_def } *} 
(*<*) thm "simple.A.r_def" (*>*) 
   text {* @{thm [display] simple.A.r_def } *} 
(*<*) thm "simple.A.r_pre_def" (*>*) 
   text {* @{thm [display] simple.A.r_pre_def } *} 

subsubsection {* Operations *}
(*<*) thm "simple.A.m_Integer_Integer.pre1.pre_0_def" (*>*) 
   text {* @{thm [display] simple.A.m_Integer_Integer.pre1.pre_0_def } *} 
(*<*) thm "simple.A.m_Integer_Integer.pre1_def" (*>*) 
   text {* @{thm [display]  simple.A.m_Integer_Integer.pre1_def } *} 

(*<*) thm "simple.A.m_Integer_Integer.post1.post_0_def" (*>*) 
   text {* @{thm [display] simple.A.m_Integer_Integer.post1.post_0_def } *} 

(*<*) thm "simple.A.m_Integer_Integer.post1_def" (*>*) 
   text {* @{thm [display]  simple.A.m_Integer_Integer.post1_def } *} 

(*

(*<*) thm "simple.A.m_Integer_Integer.m" (*>*) 
   text {* @{thm [display] simple.A..m_Integer_Integer.m } *} 
(*<*) thm "UML_OCL.ops.m_Integer.Op" (*>*) 
   text {* @{thm [display] UML_OCL.ops.m_Integer_Integer.Op } *} 
(*<*) thm "UML_OCL.ops.m_Integer_Integer.overwrite_A" (*>*)
   text {* @{thm [display] UML_OCL.ops.m_Integer_Integer.overwrite_A } *} 
*)

subsection {* Class C *}
subsubsection {* Basic Invariants *}
(*<*) thm "simple.C.model.hol_invariant.cast_def" (*>*) 
   text {* @{thm [display] simple.C.model.hol_invariant.cast_def } *} 
(*<*) thm "simple.C.model.hol_invariant_def" (*>*) 
   text {* @{thm [display] simple.C.model.hol_invariant_def } *} 

subsubsection {* Trunk: *} 
(*<*) thm "simple.mk_C_def" (*>*) 
   text {* @{thm [display] simple.mk_C_def } *} 
(*<*) thm "simple.get_C_def" (*>*) 
   text {* @{thm [display] simple.get_C_def } *} 
(*<*) thm "simple.is_C_def" (*>*) 
   text {* @{thm [display] simple.is_C_def } *} 
(*<*) thm "simple.is_C_univ_def" (*>*) 
   text {* @{thm [display] simple.is_C_univ_def } *} 
(*<*) thm "simple.C_def" (*>*) 
   text {* @{thm [display] simple.C_def } *} 
(*<*) thm "simple.C_2_A_def" (*>*) 
   text {* @{thm [display] simple.C_2_A_def } *} 
(*<*) thm "simple.A_2_C_def" (*>*) 
   text {* @{thm [display] simple.A_2_C_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "simple.C.s_def" (*>*) 
   text {* @{thm [display] simple.C.s_def } *} 
(*<*) thm "simple.C.s_pre_def" (*>*) 
   text {* @{thm [display] simple.C.s_pre_def } *} 


subsection {* Class D *}
(*
subsubsection {* Basic Invariants *} 
(*<*) thm "simple.D.model.hol_invariant.inv_0_def" (*>*) 
   text {* @{thm [display] simple.D.model.hol_invariant.inv_0_def } *} 
(*<*) thm "simple.D.model.hol_invariant.inv" (*>*) 
   text {* @{thm [display] simple.D.model.hol_invariant.inv } *} 
*)
subsubsection {* Trunk: *} 
(*<*) thm "simple.mk_D_def" (*>*) 
   text {* @{thm [display] simple.mk_D_def } *} 
(*<*) thm "simple.get_D_def" (*>*) 
   text {* @{thm [display] simple.get_D_def } *} 
(*<*) thm "simple.is_D_def" (*>*) 
   text {* @{thm [display] simple.is_D_def } *} 
(*<*) thm "simple.is_D_univ_def" (*>*) 
   text {* @{thm [display] simple.is_D_univ_def } *} 
(*<*) thm "simple.D_def" (*>*) 
   text {* @{thm [display] simple.D_def } *} 
(*<*) thm "simple.D_2_A_def" (*>*) 
   text {* @{thm [display] simple.D_2_A_def } *} 
(*<*) thm "simple.A_2_D_def" (*>*) 
   text {* @{thm [display] simple.A_2_D_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "simple.D.r_def" (*>*) 
   text {* @{thm [display] simple.D.r_def } *} 
(*<*) thm "simple.D.r_pre_def" (*>*) 
   text {* @{thm [display] simple.D.r_pre_def } *} 


subsection {* Class B *}
subsubsection {* Basic Invariants *}
(*<*) thm simple.B.model.hol_invariant.multconstraint_for_aend_a_def (*>*)
    text {* @{thm [display] simple.B.model.hol_invariant.multconstraint_for_aend_a_def } *}
(*<*) thm "simple.B.model.hol_invariant.constant_def" (*>*) 
   text {* @{thm [display] simple.B.model.hol_invariant.constant_def } *} 
(*<*) thm "simple.B.model.hol_invariant_def" (*>*) 
   text {* @{thm [display] simple.B.model.hol_invariant_def } *} 

subsubsection {* Trunk: *} 
(*<*) thm "simple.mk_B_def" (*>*)  
   text {* @{thm [display] simple.mk_B_def } *} 
(*<*) thm "simple.get_B_def" (*>*) 
   text {* @{thm [display] simple.get_B_def } *} 
(*<*) thm "simple.is_B_def" (*>*) 
   text {* @{thm [display] simple.is_B_def } *} 
(*<*) thm "simple.is_B_univ_def" (*>*) 
   text {* @{thm [display] simple.is_B_univ_def } *} 
(*<*) thm "simple.B_def" (*>*) 
   text {* @{thm [display] simple.B_def } *} 
(*<*) thm "simple.B_2_OclAny_def" (*>*) 
   text {* @{thm [display] simple.B_2_OclAny_def } *} 
(*<*) thm "simple.OclAny_2_B_def" (*>*) 
   text {* @{thm [display] simple.OclAny_2_B_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "simple.B.a_def" (*>*) 
   text {* @{thm [display] simple.B.a_pre_def } *} 
(*<*) thm "simple.B.a_pre_def" (*>*) 
   text {* @{thm [display] simple.B.a_def } *} 
(*<*) thm "simple.B.j_def" (*>*) 
   text {* @{thm [display] simple.B.j_def } *} 
(*<*) thm "simple.B.j_pre_def" (*>*) 
   text {* @{thm [display] simple.B.j_pre_def } *} 


subsection {* Class E *}
subsubsection {* Basic Invariants *} 
(*(*<*) thm "simple.E.model.hol_invariant.inv_0_def" (*>*) 
   text {* @{thm [display] simple.E.model.hol_invariant.inv_0_def } *} 
(*<*) thm "simple.E.model.hol_invariant_def" (*>*) 
   text {* @{thm [display] simple.E.model.hol_invariant_def } *} 
*)
subsubsection {* Trunk: *} 
(*<*) thm "simple.mk_E_def" (*>*) 
   text {* @{thm [display] simple.mk_E_def } *} 
(*<*) thm "simple.get_E_def" (*>*) 
   text {* @{thm [display] simple.get_E_def } *} 
(*<*) thm "simple.is_E_def" (*>*) 
   text {* @{thm [display] simple.is_E_def } *} 
(*<*) thm "simple.is_E_univ_def" (*>*) 
   text {* @{thm [display] simple.is_E_univ_def } *} 
(*<*) thm "simple.E_def" (*>*) 
   text {* @{thm [display] simple.E_def } *} 
(*<*) thm "simple.E_2_B_def" (*>*) 
   text {* @{thm [display] simple.E_2_B_def } *} 
(*<*) thm "simple.B_2_E_def" (*>*) 
   text {* @{thm [display] simple.B_2_E_def } *} 

subsubsection {* Attributes: *} 
(*<*) thm "simple.E.r_def" (*>*) 
   text {* @{thm [display] simple.E.r_def } *} 
(*<*) thm "simple.E.r_pre_def" (*>*) 
   text {* @{thm [display] simple.E.r_pre_def } *} 

 

(*
### mdr_encoder: adding invariants for level 2
### mdr_encoder: Adding constants (namespace: simple.A.invariant2):
### mdr_encoder:    inv_0 ()
### mdr_encoder: Adding constants (namespace: simple.A.invariant2):
### mdr_encoder:    invariant2 ()
### mdr_encoder: Adding defs (namespace: simple.A.invariant2):
### mdr_encoder:    invariant2: invariant2 == % obj. (simple.A.invariant2.inv_0 obj)
### mdr_encoder:    invariant2
### mdr_encoder: adding invariants for level 2
### mdr_encoder: Adding constants (namespace: simple.C.invariant2):
### mdr_encoder:    inv_0 ()
### mdr_encoder: Adding constants (namespace: simple.C.invariant2):
### mdr_encoder:    invariant2 ()
### mdr_encoder: Adding defs (namespace: simple.C.invariant2):
### mdr_encoder:    invariant2: invariant2 == % obj. (simple.C.invariant2.inv_0 obj)
### mdr_encoder:    invariant2
### mdr_encoder: adding invariants for level 2
### mdr_encoder: Adding constants (namespace: simple.D.invariant2):
### mdr_encoder:    inv_0 ()
### mdr_encoder: Adding constants (namespace: simple.D.invariant2):
### mdr_encoder:    invariant2 ()
### mdr_encoder: Adding defs (namespace: simple.D.invariant2):
### mdr_encoder:    invariant2: invariant2 == % obj. (simple.D.invariant2.inv_0 obj)
### mdr_encoder:    invariant2
### mdr_encoder: adding invariants for level 2
### mdr_encoder: Adding constants (namespace: simple.B.invariant2):
### mdr_encoder:    constant ()
### mdr_encoder: Adding constants (namespace: simple.B.invariant2):
### mdr_encoder:    invariant2 ()
### mdr_encoder: Adding defs (namespace: simple.B.invariant2):
### mdr_encoder:    invariant2: invariant2 == % obj. (simple.B.invariant2.constant obj)
### mdr_encoder:    invariant2
### mdr_encoder: adding invariants for level 2
### mdr_encoder: Adding constants (namespace: simple.E.invariant2):
### mdr_encoder:    inv_0 ()
### mdr_encoder: Adding constants (namespace: simple.E.invariant2):
### mdr_encoder:    invariant2 ()
### mdr_encoder: Adding defs (namespace: simple.E.invariant2):
### mdr_encoder:    invariant2: invariant2 == % obj. (simple.E.invariant2.inv_0 obj)
### mdr_encoder:    invariant2


*)
end



