(* ****************************************************************************
 *          HOL-OCL - a shallow embedding of OCL in Isabelle/HOL              
 *                                                                            
 * OCL_Sequence_type.thy - Type Definition for Sequence
 * Copyright (C) 2001,2002,2003,2004 Achim D. Brucker <brucker@inf.ethz.ch>   
 *                                   Burkhart Wolff   <bwolff@inf.ethz.ch>    
 *                                                                            
 * This file is part of HOL-OCL.                                              
 *                                                                            
 * HOL-OCL is free software; you can redistribute it and/or modify it under   
 * the terms of the GNU General Public License as published by the Free       
 * Software Foundation; either version 2 of the License, or (at your option)  
 * any later version.                                                         
 *                                                                            
 * HOL-OCL is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNES 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.                                                              
 *                                                                            
 * You should have received a copy of the GNU General Public License along    
 * with this program; if not, write to the Free Software Foundation, Inc.,    
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                  
 ***************************************************************************** *)

header {* Type Definition for Sequence *}
theory OCL_Sequence_type 
imports 
  "$HOLOCL_HOME/src/library/collection/OCL_Collection_type" 
  List 
begin
 text_raw{* \label{thy:OCL_Sequence_type} *}
text{* In contrast to other collections, the collection Sequence is indeed
       implemented by \emph{finite} lists. Consequently, \emph{size} is defined
       for all defined sequences. *}

typedef  'a Sequence_0 = "{X::('a::bot) list up.  True}"
  by (rule_tac x=\<bottom> in exI, simp add: smash_def)

arities  Sequence_0 :: (type) collection   (* declares \<bottom> *)

defs     UU_Sequence_def: "\<bottom> \<equiv> Abs_Sequence_0 down"

text{* The HOL type constructor for representing OCL Sequence types
       ist defined as follows: *}
types    ('st,'b) Sequence  = "('st, 'b Sequence_0) VAL"


end
