(*****************************************************************************
 *          HOL-OCL - a shallow embedding of OCL in Isabelle/HOL              
 *                                                                            
 * isar_import_setup - isar setup for import related stuff
 * Copyright (C) 2005  Achim D. Brucker <brucker@inf.ethz.ch>   
 *                                                                            
 * This file is part of HOL-OCL.                                              
 *                                                                            
 * HOL-OCL is free software; you can redistribute it and/or modify it under   
 * the terms of the GNU General Public License as published by the Free       
 * Software Foundation; either version 2 of the License, or (at your option)  
 * any later version.                                                         
 *                                                                            
 * HOL-OCL is distributed in the hope that it will be useful, but WITHOUT ANY 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more 
 * details.                                                              
 *                                                                            
 * You should have received a copy of the GNU General Public License along    
 * with this program; if not, write to the Free Software Foundation, Inc.,    
 * 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.                  
 ******************************************************************************)

structure isar_import_setup =
struct 
structure P = OuterParse and K = OuterKeyword;
 
fun load_xmiT filename thy =
    let
        fun load_mds filename thy  =
            let
		val cl = Xmi2Rep.readXMI filename;
		val cd = rep_encoder.add_classifiers rep_encoder.empty cl thy;
            in
		#theory cd
            end
        val thy = load_mds filename thy
    in
        thy
    end

val load_xmiP =
    OuterSyntax.command "load_xmi" "load XMI file"
                        OuterKeyword.thy_script
                        ((P.name)  >> (Toplevel.theory o load_xmiT));

val _ =  OuterSyntax.add_parsers [load_xmiP];

end
